# Project Name: Efren E-commerce API

## Features:

User registration\
User authentication\
Set user as admin (Admin only)\
Retrieve all active products\
Retrieve single product\
Create Product (Admin only)\
Update Product Information (Admin only)\
Archive Product (Admin only)\
Create Order (Registered User only)\
Get All Orders (Admin only)\
Get User Orders (Registered User only)\
Activate Product (Admin only)

### Admin Credentials:

email: "adminAPI@gmail.com" \
password: "adminAPI123"

### User Credentials:

email: "userApi@gmail.com" \
password: "userapi123"

## Routes and Request Body:

**User Registration:** \
POST - http://localhost/4000/users \
Body: (JSON)

```console
{
	"email": "String",
	"password": "String",
	"firstName": "String",
	"lastName": "String",
	"mobileNo": "String"
}
```

**User Login:** \
POST - http://localhost:4000/users/login \
Body: (JSON)

```console
{
    "email": "String",
    "password": "String"
}
```

**Set User as Admin:** \
PUT - http://localhost:4000/users/setAdmin/id \
Body: No Request Body \
Admin Token Required

**Get All Active Products:** \
GET - http://localhost:4000/products \
Body: No Request Body

**Get Single Product:** \
GET - http://localhost:4000/products/id \
Body: No Request Body

**Create Product:** \
POST - http://localhost:4000/products \
Body: (JSON)

```console
{
    "productName": "String",
    "description": "String",
    "price": Number
}
```

Admin Token Required

**Update Product:** \
PUT - http://localhost:4000/products/id \
Body: (JSON)

```console
{
    "productName": "String",
    "description": "String",
    "price": Number,
    "isActive": Boolean
}
```

Admin Token Required

**Archive Product:** \
PUT - http://localhost:4000/products/archive/id \
Body: No Request Body \
Admin Token Required

**Create Order:** \
POST - http://localhost:4000/users/createOrder \
Body: (JSON)

```console
{
	"products": [
		{
			"productId": "String",
	        "productName": "String",
	        "description": "String",
	        "priceSold": Number,
	        "quantity": Number,
        	"subTotalAmount": Number
		}
	],
	"totalAmount": Number
}
```

User Token Required

**Get All Orders:** \
GET - http://localhost:4000/users/allOrders \
Body: No Request Body \
Admin Token Required

**Get User Orders:** \
GET - http://localhost:4000/users/myOrders \
Body: No Request Body \
User Token Required

**Activate Product:** \
PUT - http://localhost:4000/products/activate/id \
Body: No Request Body \
Admin Token Required
